''***************************************
''*  z8Busdrive v2.2  Objekt CALC       *
''*  Author: Uwe Nickel                 *
''*  Copyright (c) 2011 by UN-Soft      *
''*  See end of file for terms of use.  *
''***************************************

' 

OBJ
    def          : "tiny_4k_def"    

PUB start (ram_adr,bmp_adr,col_mem,regxadr) 

     ram_base    := ram_adr
     bmp_buff    := bmp_adr
     col_adr     := col_mem
     reg0_adr    := regxadr
     calc_cmd_adr:= regxadr + def#calccmdreg   'phys. Adresse des Registers zur bergabe CMD
     cognew(@CALC,ram_adr)                     'Berechnung-Cog starten
               

DAT 'Berechnung- Cog
org 0
'******************************************************************************************************
'---- Mainloop ----------------------------------------------------------------------------------------
'******************************************************************************************************                  
CALC              mov calc_dat_adr, calc_cmd_adr
                  add calc_dat_adr, #1
                  mov scr_buff, bws_start
                  sub scr_buff, ram_s
                  add scr_buff, ram_base
                  add scr_buff, #$20     
                  mov xorx, xorx_mask
                  mov act_col, std_col
                  
Cmd_start         rdbyte cmdnr, calc_cmd_adr       'einlesen Kommando aus bergabezelle nach <cmdnr>
                  rdbyte calcdat,calc_dat_adr      'einlesen Datenbyte aus bergabezelle nach <calcdat>
                  cmp cmdnr, #$00          wz      '
         if_z     jmp #bws2bmp

                  cmp cmdnr, #$24          wz, wc  'Kommando kleiner gleich $24?
         if_c     jmp #Cmd_start                   'wenn kleiner, dann neu einlesen
         if_z     jmp #clear_bmp                   'wenn gleich, Bitmapspeicher mit $00 beschreiben, sonst

                  cmp cmdnr, #$25          wz      'Kommando "Bitmapspeicher mit Muster beschreiben"?
         if_z     jmp #set_bmp                     'Sprung, wenn ja

                  cmp cmdnr, #$26          wz      'Kommando "Farbausgabe negiert"? 
         if_z     mov xorx, #0
         if_z     jmp #Cmdx

                  cmp cmdnr, #$27          wz      'Kommando "Farbausgabe normal"?  
         if_z     mov xorx, xorx_mask   
         if_z     jmp #Cmdx 

                  cmp cmdnr, #$28          wz      'Kommando "farbiges Blinken1"? 
         if_z     jmp #blink_ok

                  cmp cmdnr, #$29          wz      'Kommando "farbiges Blinken2"?
         if_z     jmp #blink_err

                  cmp cmdnr, #$2C          wz      'Kommando "Standardfarben ausgeben"?
         if_z     mov act_col, std_col
         if_z     jmp #ma2    

                  cmp cmdnr, #$2D          wz      'Kommando "Farbe Vordergrund einlesen"?
         if_z     and act_col, #$FF
         if_z     shl calcdat, #8
         if_z     jmp #ma1

                  cmp cmdnr, #$2E          wz      'Kommando "Farbe Hintergrund einlesen"?  
         if_z     andn act_col, #$FF
ma1      if_z     or  act_col, calcdat  
         if_z     jmp #Cmdx              

                  cmp cmdnr, #$2F          wz      'Kommando "Farben setzen"? 
ma2      if_z     wrword act_col, col_adr
         if_nz    jmp #Cmd_start

'---- Common Part Mainloop -----------------------------------------------------------------------------
Cmdx              mov cmdnr, #$00                     'Cmd mit 00 beschreiben -> ready
                  wrbyte cmdnr, calc_cmd_adr                             
                  jmp #Cmd_start

'********************************************************************************************************  
'---- Subroutinen Monitor -------------------------------------------------------------------------------
'********************************************************************************************************
                
'......... Monitor-Blinken ..............................................................................                   
blink_ok          mov delay_cnt, delay_cnt_1
                  mov x2, col_1
                  mov x1, blink_1 
                  jmp #blink
                       
blink_err         mov delay_cnt, delay_cnt_2
                  mov x2, col_2
                  mov x1, blink_2 
                   
blink             mov temp2, x2
                  call #col_delay_xx
                  call #col_delay_0
                  djnz x1, #blink            wz
                  jmp #ma2
'------------------------------------------------------------------------------------------------------  
clear_bmp         mov temp2, #0     
                  jmp #set_bmp2                     'und zurck

'------------------------------------------------------------------------------------------------------ 
set_bmp           add calcdat, reg0_adr 
                  rdlong temp2, calcdat             'auszugebenden Wert einlesen
set_bmp2          call #bmp_set                     'und nach Bitmappuffer schreiben
                  jmp #Cmdx                         'und zurck
                  
'------------------------------------------------------------------------------------------------------ 

'------------------------------------------------------------------------------------------------------
'-------- Berechnung fr 160 x 240 Pixel --------------------------------------------------------------
'------------------------------------------------------------------------------------------------------
bws2bmp           mov bmp_ptr, bmp_buff             'Adresse Bitmapspeichr nach Pointer  
                  mov scr_ptr, scr_buff             'Adresse TINY -BWS nach Pointer

                  mov x2, #60                       'Zeilenzahl Grafikspeicher TINY
                  
Zeile_rd          mov bmp_ptrtemp, bmp_ptr      
                  mov scr_ptrtemp, scr_ptr

                  add bmp_ptrtemp,#3                'links 3 Bytes - linker Rand    
                  mov x1, #8                        'Bytezahl graf. BWS TINY pro Zeile = 8 Bytes
                  
:mx               rdbyte temp2, scr_ptrtemp         'read BWS -> temp2
                  shl temp2, #24
                  mov temp3, #8                     'Reihenfolge Bits vertauschen
:xx               shl temp2, #1    wc
                  rcr temp , #2 '1
                  djnz temp3, #:xx
                  shr temp, #16
                  xor temp, xorx
         
:zy               wrword temp, bmp_ptrtemp         'Byte nach Bitmappuffer schreiben  
      
                  add bmp_ptrtemp, #2              'Bitmappointer auf nchstes Word    
                  add scr_ptrtemp, #1              'BWS-Pointer auf nchstes Byte 
                  djnz x1, #:mx                    'zurck bis Zeilenende
              
                  add bmp_ptr, #20                 'nchster Zeilenanfang im Bitmappuffer (160 Pixel=20x8 bit)
                  add scr_ptr, #8 
                  djnz x2, #Zeile_rd               'nchste Zeile im Grafikspeicher TINY, 
 
                  jmp #Cmd_start   
     
                  
'-------------------------------------------------------------------------------------------------------
'---- Common -Parts  -----------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
bmp_set           mov len_ptr, len_bmp              'Lnge Bitmap-Puffer nach Pointer
                  mov scr_ptr, bmp_buff             'Adresse Bitmap-Puffer nach Pointer
fill_block        wrlong temp2, scr_ptr             'Bitmappufferadresse bescheiben 
                  add scr_ptr, #4                   'nchste Long-Adresse
                  djnz len_ptr, #fill_block         'zurck, wenn Lnge grer 0
fill_block_ret                   
bmp_set_ret       ret

'......................................................................................................
col_delay_0       mov temp2, std_col
col_delay_xx      mov temp, cnt
                  add temp, delay_cnt 
                  waitcnt temp, #0
                  wrword temp2, col_adr
col_delay_0_ret
col_delay_xx_ret  ret                               'und zurck
                  

'*********************************************************************************************************
'---- Data & Variable ------------------------------------------------------------------------------------
'*********************************************************************************************************              
    
 ram_base      long  0
 bmp_buff      long  0
 col_adr       long  0
 reg0_adr      long  0   
 calc_cmd_adr  long  0                             
 calc_cmd_reg  long  def#calccmdreg    
 len           long  def#lenx  
 len_bmp       long  def#lenbmp 
 std_col       long  def#stdcol
 col_1         long  def#col1
 col_2         long  def#col2
 delay_cnt_1   long  def#delay1 
 delay_cnt_2   long  def#delay1 
 blink_1       long  def#blink1
 blink_2       long  def#blink2  
 xorx_mask     long  $FFFF
 ram_s         long  def#ramstart        
 bws_start     long  def#bwsstart 

scr_buff       res   1
calc_dat_adr   res   1
calcdat        res   1
cmdnr          res   1 
temp           res   1
temp2          res   1
temp3          res   1
ptr            res   1
x1             res   1
x2             res   1   
scr_ptr        res   1
scr_end        res   1 
bmp_ptr        res   1
len_ptr        res   1
bmp_ptrtemp    res   1
scr_ptrtemp    res   1
xorx           res   1
delay_cnt      res   1
act_col        res   1

fit $1f0